config/routes.rb
Rails.application.routes.draw do
  
  namespace :api, { format: "json" } do
    resources :projects, only: [:index, :create, :show, :destroy]
  end
  

end

app/models/project.rb
class Project < ActiveRecord::Base
	self.table_name = "projects"
end

app/controllers/api/projects_controller.rb
class Api::ProjectsController < ApplicationController
	
	def index
		@projects = Project.all
		render json: @projects
	end
	
	def show
		begin
			@project = Project.find(params[:id])
			render json: @project
		rescue
			render nothing: true, status: 404
		end
	end
	
	def create
		@project = Project.new(:url => project_params[:url], :title => project_params[:title], :description => project_params[:description])
		
		if @project.save
			render json: @project, status: :created
		else
			render json: @project.errors, status:400
		end
	end
	
	def destroy
		begin
			@project = Project.find(params[:id])
			@project.destroy
			head :no_content
		rescue
			render nothing: true, status: 404
		end
	end
	
	private
		# パラメータをカプセル化
		# :titleと:descriptionのどちらかが空の場合は400
		def project_params
			params.require(:title)
			params.require(:description)
			params.permit(:url)
			params
		end
	
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :null_session
  
  # 必須パラメータが空の場合の例外処理
  rescue_from ActionController::ParameterMissing do
    render :nothing => true, :status => 400
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Codecheck996</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/projects/_form.html.erb
<%= form_for(@project) do |f| %>
  <% if @project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
      <% @project.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :url %><br>
    <%= f.text_field :url %>
  </div>
  <div class="field">
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </div>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_field :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/projects/edit.html.erb
<h1>Editing Project</h1>

<%= render 'form' %>

<%= link_to 'Show', @project %> |
<%= link_to 'Back', projects_path %>

app/views/projects/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Projects</h1>

<table>
  <thead>
    <tr>
      <th>Url</th>
      <th>Title</th>
      <th>Description</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @projects.each do |project| %>
      <tr>
        <td><%= project.url %></td>
        <td><%= project.title %></td>
        <td><%= project.description %></td>
        <td><%= link_to 'Show', project %></td>
        <td><%= link_to 'Edit', edit_project_path(project) %></td>
        <td><%= link_to 'Destroy', project, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Project', new_project_path %>

app/views/projects/new.html.erb
<h1>New Project</h1>

<%= render 'form' %>

<%= link_to 'Back', projects_path %>

app/views/projects/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Url:</strong>
  <%= @project.url %>
</p>

<p>
  <strong>Title:</strong>
  <%= @project.title %>
</p>

<p>
  <strong>Description:</strong>
  <%= @project.description %>
</p>

<%= link_to 'Edit', edit_project_path(@project) %> |
<%= link_to 'Back', projects_path %>